package com.pqs9900.serviceImpl.HisData;

import com.pqs9900.mapper.HisData.DataInHarmIMapper;
import com.pqs9900.pojo.HisData.DataInHarmI;
import com.pqs9900.pojo.HisData.DataV;
import com.pqs9900.service.HisData.DataInHarmIService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

/** @Author denghuajun
 * @Description //TODO
 * @Date  2019/2/22 9:29
 **/
@Service
public class DataInHarmIServiceImpl implements DataInHarmIService {

    private static final Logger logger= LoggerFactory.getLogger(DataInHarmIServiceImpl.class);
    @Autowired
    private ThreadPoolTaskExecutor taskExecutor;
    @Autowired
    private DataInHarmIMapper dataInHarmIMapper;
    @Override
    public int saveDataInHarmI(DataInHarmI dataInHarmI) {
        return dataInHarmIMapper.insert(dataInHarmI);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertDataInHarmI(List<DataInHarmI> list) {
        return dataInHarmIMapper.insertDataInHarmI(list);
    }

    /**
     * 采用线程池进行数据入库
     * @param listDataInHarmI 电流间谐波数据
     */
    @Override
    public Future insertDataInHarmIExecutor(List<DataInHarmI> listDataInHarmI) {
        int inum = 100 ;//每次解析入库条目数
        Callable callable = new Callable() {
            @Override
            public Object call() throws Exception {
                int nCyclicTimes;//循环次数（总长度/批量入库条目数）
                int fromIndex,toIndex;//获取数据的起始和结束下标
                try {
                    nCyclicTimes = (int) Math.ceil(listDataInHarmI.size() / (double) inum);
                    List<DataInHarmI> tmpListDataInHarmI = new ArrayList<>();
                    for (int i = 0; i < nCyclicTimes; i++) {
                        tmpListDataInHarmI.clear();
                        //假如是最后一次循环则获取循环到结束
                        fromIndex = i * inum;
                        if (i == nCyclicTimes - 1) {
                            toIndex = listDataInHarmI.size();
                        } else {
                            toIndex = (i + 1) * inum;
                        }
                        //可以先按下标截取，再入库
                        tmpListDataInHarmI.addAll(listDataInHarmI.subList(fromIndex, toIndex));
                        // TODO 做批量入库的操作
                        dataInHarmIMapper.insertDataInHarmI(tmpListDataInHarmI);
                    }
                    return "SUCCESS";
                } catch (Exception e) {
                    logger.error("电流间谐波幅值表导入异常，异常是" + e.toString());
                    return "FAIL";
                }
            }
        };
        return taskExecutor.submit(callable);
    }
}
